package example_collection_methods;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class ArrayListExamples {

	public static void main(String[] args) {
		System.out.println("ArrayList Examples\n");
		testConstructor();
		testAddAll();
	    testRetainAll();
	    testRetainAll2();
	    testRemoveAll();
	    testContainsAll();

	    // These method(s) are no longer considered in the course
	    testSubList();
	}

	private static void testConstructor() {
		System.out.println("testConstructor()");
		System.out.println("------------------------------------------------------------");
		List<String> cities = new ArrayList<>(Arrays.asList("Atlanta", "Memphis"));
		List<String> cities2 = new ArrayList<>(cities); // cities2=[Atlanta, Memphis]
		System.out.println("cities : " + cities);
		System.out.println("cities2: " + cities2);
	}
	
	private static void testAddAll() {
		System.out.println("\ntestAddAll()");
		System.out.println("------------------------------------------------------------");
		// Create a list of cities
		ArrayList<String> cities = new ArrayList<>(Arrays.asList(
				"New York", "San Francisco", "Moab"));
		
		// Create another ArrayList of cities
		ArrayList<String> cities2 = new ArrayList<>(Arrays.asList(
				"Atlanta", "Memphis"));
		
		cities.addAll(cities2);
		System.out.println("cities after cities.addAll(cities2): " + cities);
		
		ArrayList<String> cities3 = new ArrayList<>(cities2);
		System.out.println("cities3 after cities3 = new ArrayList<>(cities2): " + cities3);
	}

	private static void testRetainAll() {
		System.out.println("\ntestRetainAll()");
		System.out.println("------------------------------------------------------------");
		// Create a list of cities
		ArrayList<String> cities = new ArrayList<String>(Arrays.asList(
				"New York", "San Francisco", "Moab"));
		
		// Create another ArrayList of cities
		ArrayList<String> cities2 = new ArrayList<String>(Arrays.asList(
				"Atlanta", "Moab", "New York", "Memphis"));
		
		// retainAll() - This method takes the intersection of the two lists
		// and stores the result in "cities".
		cities.retainAll(cities2);
		System.out.println("cities after cities.retainAll(cities2): " + cities);
	    
	}

	private static void testRetainAll2() {
	    System.out.println("\ntestRetainAll2()");
	    System.out.println("------------------------------------------------------------");
		// Create a list of cities
		ArrayList<String> cities = new ArrayList<String>(Arrays.asList(
				"New York", "San Francisco", "Moab"));
		
		// Create another ArrayList of cities
		ArrayList<String> cities2 = new ArrayList<String>(Arrays.asList(
				"Atlanta", "Moab", "New York", "Memphis"));
		
		// retainAll() - This method takes the intersection of the two lists
		// and stores the result in "cities".
		ArrayList<String> citiesIntersection = new ArrayList<>(cities);
		citiesIntersection.retainAll(cities2);
		System.out.println("cities after citiesIntersection.retainAll(cities2): " + citiesIntersection);
	    
	}

	private static void testRemoveAll() {
		System.out.println("\ntestRemoveAll()");
		System.out.println("------------------------------------------------------------");
		// Create a list of cities
		ArrayList<String> cities = new ArrayList<String>(Arrays.asList(
				"New York", "San Francisco", "Moab"));
		
		// Create another ArrayList of cities
		ArrayList<String> cities2 = new ArrayList<String>(Arrays.asList(
				"Atlanta", "Moab", "New York", "Memphis"));
		
		// retainAll() - This method takes the intersection of the two lists
		// and stores the result in "cities".
		cities.removeAll(cities2);
		System.out.println("cities after cities.removeAll(cities2): " + cities);
	    
	}

	private static void testContainsAll() {
		System.out.println("\ntestContainsAll()");
		System.out.println("------------------------------------------------------------");
		// Create a list of cities
		ArrayList<String> cities1 = new ArrayList<String>(Arrays.asList(
				"New York", "San Francisco", "Moab"));
		
		// Create another ArrayList of cities
		ArrayList<String> cities2 = new ArrayList<String>(Arrays.asList(
				"Atlanta", "Moab", "New York", "Memphis"));
		
		// Create another ArrayList of cities
		ArrayList<String> cities3 = new ArrayList<String>(Arrays.asList(
				"Moab", "New York"));
		
		boolean isC2inC1 = cities1.containsAll(cities2);
		boolean isC3inC1 = cities1.containsAll(cities3);
		
		System.out.println("cities1.containsAll(cities2): " + isC2inC1);
		System.out.println("cities1.containsAll(cities3): " + isC3inC1);
	    
	}

	/*
	 * These method(s) are no longer considered in the course
	 */
	private static void testSubList() {
	    System.out.println("\nexample2()-illustrates subList method and alternate constructor)");
	    System.out.println("-----------------------------------------------------------------");
		ArrayList<String> cities = new ArrayList<String>();
		cities.add("New York"); 
		cities.add("San Francisco"); 
		cities.add("Charlotte");
		cities.add("Atlanta");
		cities.add("Durango");
		
		System.out.println("cities: " + cities);
		
		// Returns a List, not an ArrayList
		List<String> cities2 = cities.subList(2, 4);
	
		System.out.println("List<String> cities2 = cities.subList(2,4): " + cities2);
	}
}
