package example_comparator_employee;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

public class EmployeeBinarySearchTest {

	public static void main(String[] args) {
		testBinarySearchName();
		testBinarySearchSSN();		

	}
	public static void testBinarySearchName() {
		System.out.println("\ntestBinarySearchName()\n");
		Employee emp;
		List<Employee> employees = buildEmployeesList();
		
		List<Employee> empsTemp = new ArrayList<>(employees);
		EmployeeNameComparator compName = new EmployeeNameComparator();
		Collections.sort(empsTemp, compName);
		
		System.out.println("Original Order:");
		System.out.println(employees);
		System.out.println("Sorted by name:");
		System.out.println(empsTemp);
		
		emp = new Employee("A", "B", 0, 0.0);
		searchFor(empsTemp, emp, compName);
		emp = new Employee("Bartle", "Zeno", 0, 0.0);
		searchFor(empsTemp, emp, compName);
		emp = new Employee("Bartle", "Diane", 0, 0.0);
		searchFor(empsTemp, emp, compName);
		emp = new Employee("Bartle", "Dian", 0, 0.0);
		searchFor(empsTemp, emp, compName);
		
	}

	public static void testBinarySearchSSN() {
		System.out.println("\ntestBinarySearchSSN()\n");
		Employee emp;
		List<Employee> emps = new ArrayList<>();
		Employee e;
		e = new Employee("Bartle", "Zeno", 4, 23.45);
		emps.add(e);
		e = new Employee("Minton", "Fran", 2, 55.67);
		emps.add(e);

		System.out.println("Original Order:");
		System.out.println(emps);
		EmployeeSSNComparator compSSN = new EmployeeSSNComparator();
		Collections.sort(emps, compSSN);
		System.out.println("Sorted by SSN:");
		System.out.println(emps);

		emp = new Employee("a", "b", 1, 0.0);
		searchFor(emps, emp, compSSN);
		emp = new Employee("a", "b", 2, 0.0);
		searchFor(emps, emp, compSSN);
		emp = new Employee("a", "b", 3, 0.0);
		searchFor(emps, emp, compSSN);
		emp = new Employee("a", "b", 4, 0.0);
		searchFor(emps, emp, compSSN);
		emp = new Employee("a", "b", 5, 0.0);
		searchFor(emps, emp, compSSN);
		
	}
	
	public static void searchFor(List<Employee> emps, Employee e, Comparator<Employee> comp) {
		int loc = Collections.binarySearch(emps, e, comp);
		System.out.printf("\nSearched for: %s\n", e);
		if(loc >= 0) {
			Employee emp = emps.get(loc);
			System.out.printf("Found at loc=%d: %s\n", loc, emp);
		}
		else {
			System.out.printf("Not found, loc=%d\n", loc);
		}
	}

	public static List<Employee> buildEmployeesList() {
		List<Employee> emps = new ArrayList<>();
		Employee e;
		e = new Employee("Bartle", "Zeno", 443569002, 23.45);
		emps.add(e);
		e = new Employee("Minton", "Fran", 113945523, 55.67);
		emps.add(e);
		e = new Employee("Archer", "Lila", 235084421, 33.42);
		emps.add(e);
		e = new Employee("Bartle", "Diane", 338020201, 12.45);
		emps.add(e);
		return emps;
	}
	
}
