package example_comparator_employee;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

public class EmployeeSortTest {

	public static void main(String[] args) {
		testSort();
	}

	public static void testSort() {
		System.out.println("testSort()\n");
		
		// Build a list of employees
		List<Employee> employees = buildEmployeesList();
		
		// Create a new list with original employees
		List<Employee> empsName = new ArrayList<>(employees);
		EmployeeNameComparator compName = new EmployeeNameComparator();
		// Sort new list based on name
		Collections.sort(empsName, compName);
		
		List<Employee> empsSSN = new ArrayList<>(employees);
		EmployeeSSNComparator compSSN = new EmployeeSSNComparator();
		Collections.sort(empsSSN, compSSN);
		
		List<Employee> empsSalary = new ArrayList<>(employees);
		EmployeeSalaryComparator compSalary = new EmployeeSalaryComparator();
		Collections.sort(empsSalary, compSalary);
		
		System.out.println("Original Order:\n" + employees);
		System.out.println("Sorted by name:\n" + empsName);
		System.out.println("Sorted by SSN:\n" + empsSSN);
		System.out.println("Sorted by salary:\n" + empsSalary);

	}

	public static List<Employee> buildEmployeesList() {
		List<Employee> emps = new ArrayList<>();
		Employee e;
		e = new Employee("Bartle", "Zeno", 443569002, 23.45);
		emps.add(e);
		e = new Employee("Minton", "Fran", 113945523, 55.67);
		emps.add(e);
		e = new Employee("Archer", "Lila", 235084421, 33.42);
		emps.add(e);
		e = new Employee("Bartle", "Diane", 338020201, 12.45);
		emps.add(e);
		return emps;
	}
}
