package example_hash_set;

import java.util.Arrays;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

public class SetIteration {

	public static void main(String[] args) {
		testHashSet_Iteration();
		testHashSet_Remove();
		testHashSet_Remove2();
	}

	private static void testHashSet_Iteration() {
		System.out.println("testHashSet_Iteration()");
//		Set<String> names = new HashSet<>(Arrays.asList("fred", "catherine", "gordon", "fiona", "darren", "pete"));
		Set<String> names = new HashSet<>(Arrays.asList("cat", "dab", "fia", "fre", "gor", "pet"));
		names.clear();
		names.add("cat"); names.add("dab"); names.add("fia");
		names.add("fre"); names.add("gor"); names.add("pet");
		System.out.println(names);

		// for-each loop
		for(String name : names) {
			System.out.print(name + " ");
		}
		System.out.println();

		// iterator
		Iterator<String> iter = names.iterator();
		while(iter.hasNext()) {
			System.out.print(iter.next() + " ");
		}
		System.out.println();
	}

	private static void testHashSet_Remove() {
		System.out.println("\ntestHashSet_Remove()");
		Set<String> names = new HashSet<>(Arrays.asList("cat", "dab", "fia", "fre", "gor", "pet"));
		System.out.println(names);

		Iterator<String> iter = names.iterator();
		while(iter.hasNext()) {
			if(iter.next().contains("a"))
				iter.remove();
		}
		System.out.println(names);
	}

	private static void testHashSet_Remove2() {
		System.out.println("\ntestHashSet_Remove2()");
		Set<Integer> ints = new HashSet<>(Arrays.asList(4,15,2,11,3));

		Iterator<Integer> iter2 = ints.iterator();
		while(iter2.hasNext()) {
			if(iter2.next()>10) {
				iter2.remove();
			}
		}
		System.out.println(ints);
	}


}
