package example_treeset_employees;

import java.util.TreeSet;

public class EmployeeTest {
	public static void main(String[] args) {
		testContains();
		testRemove();
	}

	public static void testContains() {
		System.out.println("testContains()");
		TreeSet<Employee> emps = new TreeSet<>(new EmployeeSSNComparator());

		Employee e1 = new Employee("Boggs", "Kay", 716533892, 12.57);
		Employee e2 = new Employee("Lyton", "Ben", 476227851, 77.88);
		Employee e3 = new Employee("Boggs", "Amy", 553572246, 22.32);
		Employee e4 = new Employee("Dern", "Donald", 243558673, 23.44);

		emps.add(e1); emps.add(e2); emps.add(e3); emps.add(e4);
		
		int[] ssns = {553572246, 9};
		for(int ssn : ssns) {
			boolean isPresent = contains(emps, ssn);
			String msg = String.format("emps.contains(%d)=%b", ssn, isPresent);
			System.out.println(msg);
		}

	}

	public static void testRemove() {
		System.out.println("\ntestRemove()");
		TreeSet<Employee> emps = new TreeSet<>(new EmployeeSSNComparator());

		Employee e1 = new Employee("Boggs", "Kay", 716533892, 12.57);
		Employee e2 = new Employee("Lyton", "Ben", 476227851, 77.88);
		Employee e3 = new Employee("Boggs", "Amy", 553572246, 22.32);
		Employee e4 = new Employee("Dern", "Donald", 243558673, 23.44);

		emps.add(e1); emps.add(e2); emps.add(e3); emps.add(e4);
		
		int[] ssns = {553572246, 9};
		for(int ssn : ssns) {
			boolean isRemoved = remove(emps, ssn);
			String msg = String.format("emps.contains(%d)=%b", ssn, isRemoved);
			System.out.println(msg);
		}

	}

	private static boolean contains(TreeSet<Employee> emps, int ssn) {
		Employee key = new Employee("", "", ssn, 0);
		return emps.contains(key);
	}

	private static boolean remove(TreeSet<Employee> emps, int ssn) {
		Employee key = new Employee("", "", ssn, 0);
		return emps.remove(key);
	}

}
