package exercise_get_ids;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.TreeSet;

public class StudentTest {

	public static void main(String[] args) {
		testGetIds();
	}

	private static void testGetIds() {
		System.out.println("testGetIds()");
		TreeSet<Student> students1 = new TreeSet<Student>(Arrays.asList( 
		         new Student(33,56.7),
					new Student(77,88.2),
					new Student(11,79.1),
					new Student(66,95.3),
					new Student(44,83.1),
					new Student(22,45.3) ) );

		TreeSet<Student> students2 = new TreeSet<Student>(Arrays.asList( 
		         new Student(66,48.7),
					new Student(45,51.6),
					new Student(26,69.3),
					new Student(77,69.3),
					new Student(33,55.3) ) );
		
		List<Integer> ids = getIds(students1, students2);
		List<Integer> ids2 = getIds2(students1, students2);
		
		System.out.println("students1: " + students1);
		System.out.println("students2: " + students2);
		System.out.println("ids 1: " + ids);
		System.out.println("ids 2: " + ids2);
	}

	public static List<Integer> getIds(TreeSet<Student> students1, TreeSet<Student> students2) {
		List<Integer> ids = new ArrayList<Integer>();
		
		for( Student s : students1 ) {
			if(students2.contains(s)) {
				ids.add(s.getId());
			}
		}
		return ids;
	}

	public static List<Integer> getIds2(TreeSet<Student> students1, TreeSet<Student> students2) {
		List<Integer> ids = new ArrayList<Integer>();
		TreeSet<Student> sCommon = new TreeSet<Student>(students1);
		sCommon.retainAll(students2);
	
		for(Student s : sCommon) {
			ids.add(s.getId());
		}
		return ids;
	}

}
