package exercise_get_paid_list;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

public class GetPaidTest {

	public static void main(String[] args) {
		testGetPaidListAndGetNotPaidList();
	}

	private static void testGetPaidListAndGetNotPaidList() {
		List<String> names = new ArrayList<String>( Arrays.asList( "t", "b", "d", "g", "m", "e" ) );
		Set<Integer> iPaid = new HashSet<Integer>( Arrays.asList( 1,4,2 ) );
		
		System.out.println( "All names: " + names );
		
		// 3 ways to solve problem.
		System.out.println( "Paid names  : " + getPaidList( names, iPaid ) );
		System.out.println( "Paid names 2: " + getPaidList2( names, iPaid ) );
		System.out.println( "Paid names 3: " + getPaidList3( names, iPaid ) );
		
		// 2 ways to solve
		System.out.println( "Not paid names  : " + getNotPaidList( names, iPaid ) );
		System.out.println( "Not paid names 2: " + getNotPaidList2( names, iPaid ) );
	}

	public static List<String> getPaidList(List<String> names, Set<Integer> iPaid) {
		List<String> paidNamesList = new ArrayList<String>();

		for(int i : iPaid) {
			paidNamesList.add(names.get(i));
		}
		return paidNamesList;
	}

	public static List<String> getPaidList2(List<String> names, Set<Integer> iPaid) {
		List<String> paidNamesList = new ArrayList<String>();

		for(int i=0; i<names.size(); i++) {
			if(iPaid.contains(i)) {
				paidNamesList.add(names.get(i));
			}
		}
		return paidNamesList;
	}

	public static List<String> getPaidList3(List<String> names, Set<Integer> iPaid) {
		List<String> paidNamesList = new ArrayList<String>();

		Iterator<Integer> iter = iPaid.iterator();
		while(iter.hasNext()) {
			paidNamesList.add(names.get(iter.next()));
		}
		return paidNamesList;
	}
	
	// Problem 2 
	// Write a method, notPaidList that is the same as getPaidList except that it
	// returns the list of names that have NOT paid their bill.
	public static List<String> getNotPaidList(List<String> names, Set<Integer> iPaid) {
		List<String> notPaidList = new ArrayList<String>();
		
		for(int i=0; i<names.size(); i++) {
			if(!iPaid.contains(i)) {
				notPaidList.add(names.get(i));
			}
		}
		return notPaidList;
	}


	// Problem 2 - Alternate approach
	public static List<String> getNotPaidList2(List<String> names, Set<Integer> iPaid) {
		List<String> notPaidList = new ArrayList<String>(names);
		List<String> paidList = getPaidList(names, iPaid);
		notPaidList.removeAll(paidList);
		return notPaidList;
	}

}
