package exercise_jerseys;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class JerseyMethods {
	public static void main(String[] args) {
		List<Integer> jerseys1 = new ArrayList<>(Arrays.asList(1,2,3,4,5));
		List<Integer> jerseys2 = new ArrayList<>(Arrays.asList(9,2,7,4,8));
		System.out.println("jerseys1=" + jerseys1);
		System.out.println("jerseys2=" + jerseys2);
		
		System.out.println("commonJerseys=" + commonJerseys(jerseys1,jerseys2));
		System.out.println("firstButNotSecond =" + firstButNotSecond(jerseys1,jerseys2));
		System.out.println("firstButNotSecond2=" + firstButNotSecond2(jerseys1,jerseys2));
		System.out.println("mergeJerseys =" + mergeJerseys(jerseys1,jerseys2));
		System.out.println("mergeJerseys2=" + mergeJerseys2(jerseys1,jerseys2));
		System.out.println("mergeJerseys3=" + mergeJerseys3(jerseys1,jerseys2));
		System.out.println("notInBoth=" + notInBoth(jerseys1,jerseys2));
		System.out.println("notInBoth2=" + notInBoth2(jerseys1,jerseys2));

		/*
		 * Tests for practice problem methods that are not longer assigned
		 */
		System.out.println();
		jerseys1 = new ArrayList<>(Arrays.asList(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15));
		System.out.println("combine=" + combine(jerseys1,1,3,6,7));

		System.out.println();
		jerseys2 = new ArrayList<>(Arrays.asList(1,2,3,4,5,6,7,8,9,10));
		jerseys1 = new ArrayList<>(Arrays.asList(40,50,60));
		System.out.println("jerseys1=" + jerseys1);
		System.out.println("jerseys2=" + jerseys2);
		equalize(jerseys1,jerseys2);
		System.out.println("equalized=");
		System.out.println("jerseys1=" + jerseys1);
		System.out.println("jerseys2=" + jerseys2);

		System.out.println();
		jerseys1 = new ArrayList<>(Arrays.asList(1,2,3,4,5,6,7,8,9,10));
		System.out.println("randSubList=" + randSubList(jerseys1));
		jerseys1 = new ArrayList<>(Arrays.asList(1,2));
		System.out.println("randSubList=" + randSubList(jerseys1));

	}

	public static List<Integer> commonJerseys(List<Integer> jerseys1, List<Integer> jerseys2) {
		List<Integer> common = new ArrayList<>(jerseys1);
		common.retainAll(jerseys2);
		return common;
	}

	public static List<Integer> firstButNotSecond(List<Integer> jerseys1, List<Integer> jerseys2) {
		List<Integer> firstOnly = new ArrayList<>(jerseys1);
		firstOnly.removeAll(jerseys2);
		return firstOnly;
	}

	// Uses contains.
	public static List<Integer> firstButNotSecond2(List<Integer> jerseys1, List<Integer> jerseys2) {
		List<Integer> firstOnly = new ArrayList<>();
		for(int jerseyNum : jerseys1) {
			if(!jerseys2.contains(jerseyNum)) {
				firstOnly.add(jerseyNum);
			}
		}
		return firstOnly;
	}
	
	public static List<Integer> mergeJerseys(List<Integer> jerseys1, List<Integer> jerseys2) {
		List<Integer> intersection = new ArrayList<>(jerseys1);
		intersection.retainAll(jerseys2);
		List<Integer> notInList1 = new ArrayList<>(jerseys2);
		notInList1.removeAll(intersection);
		List<Integer> merged = new ArrayList<>(jerseys1);
		merged.addAll(notInList1);
		return merged;
	}

	public static List<Integer> mergeJerseys2(List<Integer> jerseys1, List<Integer> jerseys2) {
		List<Integer> result = new ArrayList<>(jerseys1);
		for(int jersey : jerseys2) {
			if(!result.contains(jersey)) {
				result.add(jersey);
			}
		}
		return result;
	}

	// Doesn't use contains.
	public static List<Integer> mergeJerseys3(List<Integer> jerseys1, List<Integer> jerseys2) {
		List<Integer> result = new ArrayList<>(jerseys1);
		for(int jersey : jerseys2) {
			boolean isFound=false;
			for(int jResult : result) {
				if(jersey == jResult) {
					isFound = true;
					break;
				}
			}
			if(!isFound) {
				result.add(jersey);
			}
		}
		return result;
	}

	
	public static List<Integer> notInBoth(List<Integer> jerseys1, List<Integer> jerseys2) {
		List<Integer> result = new ArrayList<>(firstButNotSecond(jerseys1,jerseys2));
		result.addAll(firstButNotSecond(jerseys2,jerseys1));
		return result;
	}
	
	public static List<Integer> notInBoth2(List<Integer> jerseys1, List<Integer> jerseys2) {
		List<Integer> notInBoth = new ArrayList<>();
		for(int jerseyNum : jerseys1) {
			if(!jerseys2.contains(jerseyNum)) {
				notInBoth.add(jerseyNum);
			}
		}
		for(int jerseyNum : jerseys2) {
			if(!jerseys1.contains(jerseyNum)) {
				notInBoth.add(jerseyNum);
			}
		}
		return notInBoth;
	}

	/*
	 * The methods below belong to practice problems that are no longer in the text
	 */
	public static List<Integer> combine(List<Integer> jerseys1, int a, int b, int c, int d) {
		List<Integer> newList = new ArrayList<>();
		newList.addAll(jerseys1.subList(a, b+1));
		newList.addAll(jerseys1.subList(c, d+1));
		return newList;
	}

	public static void equalize(List<Integer> jerseys1, List<Integer> jerseys2) {
		List<Integer> extra = jerseys2.subList(jerseys1.size(), jerseys2.size());
		jerseys2.removeAll(extra);
	}

	public static List<Integer> randSubList(List<Integer> jerseys1) {
		List<Integer> subList;
		int loc1, loc2;
		loc1 = (int)((jerseys1.size())*Math.random());
		// if loc1 is last last element then loc2 is length of list so
		// that sublist will be just last element.
		if(loc1==jerseys1.size()-1) {
			loc2 = loc1+1;
		}
		else {
			loc2 = (int)(loc1+1+(jerseys1.size()-loc1)*Math.random());
		}
		subList = jerseys1.subList(loc1, loc2);
		return subList;
	}


}
